// Generated by purs version 0.14.3
"use strict";
var Ansi_Codes = require("../Ansi.Codes/index.js");
var Control_Applicative = require("../Control.Applicative/index.js");
var Data_Eq = require("../Data.Eq/index.js");
var Data_Functor = require("../Data.Functor/index.js");
var Data_List = require("../Data.List/index.js");
var Data_List_NonEmpty = require("../Data.List.NonEmpty/index.js");
var Data_List_Types = require("../Data.List.Types/index.js");
var Data_Maybe = require("../Data.Maybe/index.js");
var Dodo = require("../Dodo/index.js");
var AnsiBuffer = function (x) {
    return x;
};
var underline = Dodo.annotate(new Ansi_Codes.PMode(Ansi_Codes.Underline.value));
var strikethrough = Dodo.annotate(new Ansi_Codes.PMode(Ansi_Codes.Strikethrough.value));
var reset = Dodo.annotate(Ansi_Codes.Reset.value);
var italic = Dodo.annotate(new Ansi_Codes.PMode(Ansi_Codes.Italic.value));
var inverse = Dodo.annotate(new Ansi_Codes.PMode(Ansi_Codes.Inverse.value));
var foreground = function (color) {
    return Dodo.annotate(new Ansi_Codes.PForeground(color));
};
var dim = Dodo.annotate(new Ansi_Codes.PMode(Ansi_Codes.Dim.value));
var bold = Dodo.annotate(new Ansi_Codes.PMode(Ansi_Codes.Bold.value));
var background = function (color) {
    return Dodo.annotate(new Ansi_Codes.PBackground(color));
};
var ansiGraphics = (function () {
    var writePendingGraphics = function (v) {
        if (v.pending instanceof Data_Maybe.Nothing) {
            return v;
        };
        if (v.pending instanceof Data_Maybe.Just) {
            return {
                output: v.output + Ansi_Codes.escapeCodeToString(new Ansi_Codes.Graphics(v.pending.value0)),
                pending: Data_Maybe.Nothing.value,
                current: v.current,
                previous: v.previous
            };
        };
        throw new Error("Failed pattern match at Dodo.Ansi (line 136, column 5 - line 143, column 12): " + [ v.pending.constructor.name ]);
    };
    var writeText = function (v) {
        return function (text) {
            return function (output) {
                var v1 = writePendingGraphics(output);
                return {
                    output: v1.output + text,
                    pending: v1.pending,
                    current: v1.current,
                    previous: Data_List_Types.Nil.value
                };
            };
        };
    };
    var writeIndent = function (v) {
        return function (text) {
            return function (v1) {
                return {
                    output: v1.output + text,
                    pending: v1.pending,
                    current: v1.current,
                    previous: v1.previous
                };
            };
        };
    };
    var resetCode = Ansi_Codes.escapeCodeToString(Ansi_Codes.Graphics.create(Control_Applicative.pure(Data_List_Types.applicativeNonEmptyList)(Ansi_Codes.Reset.value)));
    var graphicsConflict = function (v) {
        return function (v1) {
            if (v instanceof Ansi_Codes.Reset && v1 instanceof Ansi_Codes.Reset) {
                return true;
            };
            if (v instanceof Ansi_Codes.PForeground && v1 instanceof Ansi_Codes.PForeground) {
                return true;
            };
            if (v instanceof Ansi_Codes.PBackground && v1 instanceof Ansi_Codes.PBackground) {
                return true;
            };
            if (v instanceof Ansi_Codes.PMode && v1 instanceof Ansi_Codes.PMode) {
                return Data_Eq.eq(Ansi_Codes.eqRenderingMode)(v.value0)(v1.value0);
            };
            return false;
        };
    };
    var getPendingGraphics = (function () {
        var $42 = Data_Functor.map(Data_Maybe.functorMaybe)(Data_List_NonEmpty.cons(Ansi_Codes.Reset.value));
        return function ($43) {
            return $42(Data_List_NonEmpty.fromList($43));
        };
    })();
    var writeBreak = function (v) {
        var pending = getPendingGraphics(v.current);
        var resetOrEmpty = (function () {
            var $34 = Data_Maybe.isNothing(pending) && Data_List["null"](v.previous);
            if ($34) {
                return "";
            };
            return resetCode;
        })();
        return {
            output: v.output + (resetOrEmpty + "\x0a"),
            pending: pending,
            current: v.current,
            previous: v.previous
        };
    };
    var getCurrentGraphics = (function () {
        var $44 = Data_List.nubByEq(graphicsConflict);
        var $45 = Data_List.takeWhile(function (v) {
            return Data_Eq.notEq(Ansi_Codes.eqGraphicsParam)(v)(Ansi_Codes.Reset.value);
        });
        return function ($46) {
            return Data_List.reverse($44($45($46)));
        };
    })();
    var leaveAnnotation = function (a) {
        return function (as) {
            return function (v) {
                var current = getCurrentGraphics(as);
                return {
                    output: v.output,
                    pending: Data_Maybe.Just.create(Data_Maybe.fromMaybe(Control_Applicative.pure(Data_List_Types.applicativeNonEmptyList)(Ansi_Codes.Reset.value))(getPendingGraphics(current))),
                    current: current,
                    previous: v.current
                };
            };
        };
    };
    var flushBuffer = function (ansiBuffer) {
        var v = writePendingGraphics(ansiBuffer);
        return v.output;
    };
    var enterAnnotation = function (a) {
        return function (as) {
            return function (v) {
                var current = getCurrentGraphics(new Data_List_Types.Cons(a, as));
                return {
                    output: v.output,
                    pending: getPendingGraphics(current),
                    current: current,
                    previous: v.current
                };
            };
        };
    };
    var emptyBuffer = {
        output: "",
        pending: Data_Maybe.Nothing.value,
        current: Data_List_Types.Nil.value,
        previous: Data_List_Types.Nil.value
    };
    return {
        emptyBuffer: emptyBuffer,
        writeText: writeText,
        writeIndent: writeIndent,
        writeBreak: writeBreak,
        enterAnnotation: enterAnnotation,
        leaveAnnotation: leaveAnnotation,
        flushBuffer: flushBuffer
    };
})();
module.exports = {
    AnsiBuffer: AnsiBuffer,
    ansiGraphics: ansiGraphics,
    background: background,
    bold: bold,
    dim: dim,
    foreground: foreground,
    inverse: inverse,
    italic: italic,
    reset: reset,
    strikethrough: strikethrough,
    underline: underline,
    Black: Ansi_Codes.Black,
    Blue: Ansi_Codes.Blue,
    BrightBlack: Ansi_Codes.BrightBlack,
    BrightBlue: Ansi_Codes.BrightBlue,
    BrightCyan: Ansi_Codes.BrightCyan,
    BrightGreen: Ansi_Codes.BrightGreen,
    BrightMagenta: Ansi_Codes.BrightMagenta,
    BrightRed: Ansi_Codes.BrightRed,
    BrightWhite: Ansi_Codes.BrightWhite,
    BrightYellow: Ansi_Codes.BrightYellow,
    Cyan: Ansi_Codes.Cyan,
    Green: Ansi_Codes.Green,
    Magenta: Ansi_Codes.Magenta,
    Red: Ansi_Codes.Red,
    White: Ansi_Codes.White,
    Yellow: Ansi_Codes.Yellow
};
